bi_gene<- read.delim("./data/GBM_biclustering_gene.csv",header=FALSE)
bi_sample <- read.delim("./data/GBM_biclustering_sample.csv",header=FALSE)

gexp<- read.delim("./data/GBM_mRNA_tumor.txt",header=FALSE)
gene_list <- as.vector(unlist(read.delim("./data/GBM_genelist3.txt",header=FALSE)))

# save module information
module_num <- nrow(bi_gene) 
module_gene_list <- list()
module_sample_list <- list()
module_mirna_list <- list()
module_gene_list <- list()

attach(module_gene_list)
for(i in 1:module_num){
  module_genes <- unlist(strsplit(as.character(bi_gene[i,]),","))
  module_genes <- module_genes[!module_genes==""] 
  module_gene_list[[i]] <- module_genes
}
detach(module_gene_list)

attach(module_sample_list)
for(i in 1:module_num){
  module_samples <- unlist(strsplit(as.character(bi_sample[i,]),","))
  module_samples <- module_samples[!module_samples==""]
  module_sample_list[[i]] <- module_samples
}
detach(module_sample_list)

sd_mean_list <- NULL     
pval_list <- NULL
gene_len <- nrow(gexp)
sample_len <- ncol(gexp)

thres <- 0.05
nTest <- 1000
for(i in 1:module_num)
{
  nCount <- 0
  print(i)

# retrieve sample idx

  sample_idx <- as.numeric(substr(as.character(module_sample_list[[i]]),7,10))


  # retrieve gene expression
  module_gene <-  module_gene_list[[i]]
  module_gene_exp <- NULL
  for(j in 1:length(module_gene))
  {
      module_gene_exp <- rbind(module_gene_exp,gexp[which(module_gene[j] == gene_list),sample_idx])
      
  }        

  to_numeric <- t(module_gene_exp)
  class(to_numeric) <- "numeric"
  module_cor <- cor(to_numeric)
  module_cor_list <- module_cor[lower.tri(module_cor,diag=FALSE)]
  module_cor_ave <- mean(abs(module_cor_list),na.rm=TRUE)
  for(j in 1:nTest){
    #print(j)
    random_gexp <- gexp[sample(1:gene_len,length(module_gene)),sample(1:sample_len,length(sample_idx))]
    to_numeric2 <- t(random_gexp)
    class(to_numeric2) <- "numeric"
    random_cor <- cor(to_numeric2)
    #random_cor <- cor(t(random_gexp))
    random_cor_list <- random_cor[lower.tri(random_cor,diag=FALSE)]
    random_cor_ave <- mean(abs(random_cor_list),na.rm=TRUE)
    if(random_cor_ave > module_cor_ave){
      nCount <- nCount + 1
    }
    
  }
  pval_list <- c(pval_list,nCount / nTest)
    
}

write.table(pval_list,"./result/GBM_cluster_p_value.txt",col.names=FALSE,row.names=FALSE)

                                                 