# set list data structure
gexp <- read.delim("./data/GBM_mRNA_normalized.txt",header=FALSE)
gene_list <- as.vector(unlist(read.delim("./data/GBM_genelist.txt",header=FALSE)))
module_info <- read.delim("./data/GBM_biclustering_gene.csv",header=FALSE)
bi_sample <- read.delim("./data/GBM_biclustering_sample.csv",header=FALSE)

module_gene_list <- list()
module_sample_list <- list()
all_gg_pair <- read.delim("./data/PPI.txt",header=FALSE)

attach(module_gene_list)
for(i in 1:nrow(module_info)){
 module_genes <- unlist(strsplit(as.character(module_info[i,]),","))
  module_genes <- module_genes[!module_genes==""]
  module_gene_list[[i]] <- module_genes
}
detach(module_gene_list)

attach(module_sample_list)
for(i in 1:nrow(module_info)){
  module_samples <- unlist(strsplit(as.character(bi_sample[i,]),","))
  module_samples <- module_samples[!module_samples==""]
  module_sample_list[[i]] <- module_samples
}
detach(module_sample_list)

temp <- all_gg_pair
all_gg_pair <-NULL
for(i in 1:nrow(temp)){
print(i)
if(as.character(temp[i,1]) != as.character(temp[i,2])){
all_gg_pair <- rbind(all_gg_pair,temp[i,])
}
}
               

gg_pair <- NULL
sub_gg_pair <- NULL
new_module_gene_list <- NULL
for(i in 1:length(module_gene_list))
{
  print(i)
  module_genes <- module_gene_list[[i]]
  module_sample_idx <- as.numeric(substr(as.character(module_sample_list[[i]]),7,10))
  for(j in 1:length(module_genes))
  {
    sub_gg_pair1 <- all_gg_pair[which(module_genes[j] == as.vector(all_gg_pair[,1])),]
    sub_gg_pair2 <- all_gg_pair[which(module_genes[j] == as.vector(all_gg_pair[,2])),]

    sub_gg_pair <- rbind(sub_gg_pair1,sub_gg_pair2)
    gg_pair <- rbind(gg_pair,sub_gg_pair)
    
  }
  gg_genes <- unique(as.vector(unlist(gg_pair)))
  gg_genes <- setdiff(gg_genes,module_genes)
  
  #find module_genes and gg_genes
                             

  module_gene_idx <- NULL
  for(j in 1:length(module_genes))  
  {
    module_gene_idx <- c(module_gene_idx,which(gene_list == module_genes[j]))
  }
  
  gg_gene_idx <- NULL

  for(j in 1:length(gg_genes))  
  {
    gg_gene_idx <- c(gg_gene_idx,which(gene_list == gg_genes[j]))
  }

  
            

  idx <- union(module_gene_idx,gg_gene_idx)
  mgg_genes <- gene_list[idx]            

   
  sub_gexp <- gexp[idx,module_sample_idx]
  
  mgg_cor_mat <- cor(t(sub_gexp))
  module_gexp <- gexp[module_gene_idx,module_sample_idx]
  
 
  module_cor_mat <- cor(t(module_gexp))

  
  # PCC average
  thres1 <- mean(abs(module_cor_mat[upper.tri(module_cor_mat)]))
  thres2 <- mean(abs(module_cor_mat[lower.tri(module_cor_mat)]))
  thres <- (thres1 + thres2)/ 2
    
  
  gg_cor_mat <- mgg_cor_mat
  gg_cor_mat <- gg_cor_mat[1:length(module_gene_idx),-(1:length(module_gene_idx))]

 
  cor_mean <- as.vector(apply(abs(gg_cor_mat),2,mean))
  co <- order(cor_mean,decreasing=TRUE)

  # Expanding
  module_gene_idx <- 1:length(module_gene_idx)
  module_gene_num <- length(module_gene_idx)
  for(j in 1:length(gg_gene_idx))
  { 
    print(thres)
    prev_thres <- thres
    prev_module_gene_idx <- module_gene_idx
    module_gene_idx <- c(module_gene_idx,co[j] + module_gene_num)
    module_cor_mat <- mgg_cor_mat[module_gene_idx,module_gene_idx]
    
    thres1 <- mean(abs(module_cor_mat[upper.tri(module_cor_mat)]))
    thres2 <- mean(abs(module_cor_mat[lower.tri(module_cor_mat)]))
    thres <- (thres1 + thres2)/ 2
    
    if(thres < prev_thres)
    {
      module_gene_idx <- prev_module_gene_idx 
      break
    }
  }
  
  new_module_gene_list[[i]] <- union(module_gene_list[[i]],mgg_genes[module_gene_idx]) 
}                 

num_mat <- matrix(nrow=length(module_gene_list),ncol=2)
for(i in 1:length(new_module_gene_list))
{
  num_mat[i,1] <- length(module_gene_list[[i]])
  num_mat[i,2] <- length(new_module_gene_list[[i]])
}
for(i in 1:length(new_module_gene_list)) 
{
	write.table(num_mat,"./result/changedinfo_GBM_clusters.txt",col.names=FALSE,row.names=FALSE)
	write.table(t(as.character(new_module_gene_list[[i]])),"./result/GBM_new_biclustering_gene.csv",sep=",",qmethod="double",append=TRUE,col.names=FALSE,row.names=FALSE)
}                               