pmat <- read.table("./data/GBM_protein_miRNA_norm_mat.txt")
gmat <- read.table("./data/GBM_mRNA_miRNA_norm_mat.txt")
class <- read.table("./data/GBM_miRNA_class.txt")


roww <- nrow(pmat)
coll <- ncol(pmat)




result <- NULL
sclass <- NULL
num <- NULL
inter <- NULL
union <- NULL

whole <- rbind(pmat,gmat)

#we used two kinds of thresholds: 5%(0.05,0.95) and 1%(0.01,0.99) 
thres <- quantile(as.vector(unlist(whole)),0.05)
thresplus <- quantile(as.vector(unlist(whole)),0.95)


for ( i in 1:coll ) {

	gcol <- gmat[,i]
	pcol <- pmat[,i]

	#count the genes when their absolute values satisfy the conditions on both matrices
	interplus <- intersect((which(gcol > thresplus)),(which(pcol > thresplus)))
	interminus <- intersect((which(gcol < thres)),(which(pcol < thres)))
	
	num <- length(interplus) + length(interminus)
	
	result <- c(result,num)

}


class <- cbind (class, result)

sclass <- class[order(-result), ]




write.table(sclass,"./result/GBM_ranklist_norm_abs5.txt",col.names=FALSE,row.names=FALSE,sep="\t")


